device_create
Prev | Device Drivers Base | Next

## Name

device_create — creates a device and registers it with sysfs

## Synopsis

`struct device * device_create (` | struct class * | class,
| struct device * | parent,
| dev_t | devt,
| const char * | fmt,
|  | ...`)`;

## Arguments

`class`

  pointer to the struct class that this device should be registered to

`parent`

  pointer to the parent struct device of this new device, if any

`devt`

  the dev_t for the char device to be added

`fmt`

  string for the device's name

`...`

  variable arguments

## Description

This function can be used by char device classes. A struct device will be created in sysfs, registered to the specified class.

A “dev” file will be created, showing the dev_t for the device, if the dev_t is not 0,0. If a pointer to a parent struct device is passed in, the newly created struct device will be a child of that device in sysfs. The pointer to the struct device will be returned from the call. Any further sysfs files that might be required can be created using this pointer.

## Note

the struct class passed to this function must have previously been created with a call to `class_create`.

Prev | Up | Next
device_find_child | Home | device_destroy